SystemOrganization addCategory: #'Khami-Web'!

WAFileLibrary subclass: #KmResources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmResources methodsFor: 'css' stamp: 'StuartHerring 4/26/2011 12:40'!
styleCss
	^'html {
	background: #aaccff;
	font-family: sans-serif;
}

.clickable {
	cursor: pointer;
}

#sidebar {
	float: left;
	width: 10em;
	margin-right: 0.5em;
	background: silver;
}

#sidebar h2 {
	font-size: 0.8em;
	background-color: gray;
	margin: 0;
	line-height: 1.5em;
	text-align: center;
	vertical-align: middle;
}

#tilelist p {
	margin: 0;
	text-align: center;
	font-size: 0.8em;
	font-weight: bold;
	float: left;
	color: white;
}

#tilelist a {
	float: right;
	clear: right;
	margin-bottom: 1em;
	font-size: 0.8em;
}

#summary {
	padding: 0.5em;
	margin: 0;
	width: 9em;
}


#summary dt {
	clear: left;
	font-weight: bold;
	width: 4em;
}

#summary dd {
	clear: right;
	margin-left: 0.5em;
	width: 3em;
}

ul#menu { 
	padding: 0;
	margin: 0;
	margin-bottom: 5px;
}

#menu li {
	padding-left: 3px;
	padding-right: 3px;
	margin: 0;
	list-style: none;
	border-bottom: 1px solid black;
}

#menu li:hover {
	background: gray;
}

#menu li a {
	text-decoration: none;
	color: #aa0000;
	margin: 0;
	font-size: 0.8em;
}

#menu li a:hover {
	color: silver;
}

table.gameBoard {
	border-collapse: collapse;
	border-color: gray;
	padding: 0;
}

table.gameBoard td {
	width: 52px;
	height: 52px;
	padding: 0px;
}

table.gameBoard td.available {
	background-color: white;
}

table.gameBoard td.available:hover {
	background-color: silver;
}

table.gameBoard td.available a {
	display: block;
	margin: 0;
	height: 100%;
	width: 100%;
	text-decoration: none;
}

table.KmTile {
	border: 1px black solid;
	padding: 0;
	border-spacing: 0;
	border-collapse: collapse;
}

table.KmTile td {
	width: 10px;
	height: 10px;
	line-height: 6px;
	background-color: transparent;
	padding: 0;
	font-size: 6px;
	text-align: center;
	vertical-align: middle;
}

table.KmTile td.text {
	line-height: 1em;
	width: 50px;
	height: 50px;
	text-align: center;
	font-size: 1em;
}

.KmTile td.farm {
	background: green;
}

.KmTile td.farmC {
	background: lime;
}

.KmTile td.village {
	background: maroon;
	color: silver;
}

.KmTile td.villageC {
	background: red;
}

.KmTile td.wall {
	background: #550000;
}

.KmTile td.road {
	background: white;
}

.KmTile td.roadC {
	background: black;
	color: silver;
}

.KmTile td.hut {
	background: cyan;
}
'! !

WAComponent subclass: #KmChooseTileSet
	instanceVariableNames: 'tileSets tileSet savedGame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmChooseTileSet class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 08:54'!
canBeRoot
	^true! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 15:33'!
initialize
	super initialize.
	tileSets := KmTileSet tileSets asOrderedCollection.
	tileSet := tileSets first.! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/10/2011 22:16'!
renderContentOn: html
	html heading level: 1; with: 'Choose a tile set or Upload Game'.
	html form multipart; with: [
		self renderTileSetsOn: html.
		self renderUploadOn: html.
		html submitButton callback: [ self submitClicked]; with: 'Ok'].! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/21/2011 23:07'!
renderTileSetsOn: html
	html select 
		on: #tileSet of: self; 
		list: tileSets;
		labels: [ :ts | ts tilesetName]! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/10/2011 22:22'!
renderUploadOn: html
	html div: [
		html fileUpload callback: [ :f | savedGame := Object readSixxFrom: f contents]]! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/10/2011 22:14'!
submitClicked
	self answer: (savedGame ifNil: [KmGame tileSet: tileSet new])! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 09:01'!
tileSet
	^tileSet! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 10:12'!
tileSet: aSet
	tileSet := aSet! !

WAComponent subclass: #KmDownloadGameLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmDownloadGameLink methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/10/2011 22:03'!
gameState
	^self session game sixxString! !

!KmDownloadGameLink methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/10/2011 22:05'!
renderContentOn: html
	html heading: 'Download Game State'.
	html anchor document: self gameState  mimeType:  'text/xml' fileName: 'vok-', DateAndTime now printString, '.xml';
		with: 'Click Here to Download Game'.
	html horizontalRule.
	html anchor callback: [self answer]; with: 'Done'! !

WAComponent subclass: #KmGameBoardComponent
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameBoardComponent class methodsFor: 'instance creation' stamp: 'StuartHerring 1/12/2011 19:28'!
for: aGame
	^self basicNew
		initializeWithGame: aGame;
		yourself! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:48'!
at: row at: column
	^game board at: row at: column! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:48'!
columns 
	^game board columns! !

!KmGameBoardComponent methodsFor: 'initialization' stamp: 'StuartHerring 1/17/2011 10:45'!
initializeWithGame: aGame
	self initialize.
	game:= aGame! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:50'!
placeTileAt: row at: column
	game placeTileAt: row at: column! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 15:33'!
renderAvailableSpotFor: row at: column on: html
	html tableData class: #available; 
		onClick: ('window.location="', (html urlForAction: [self placeTileAt: row at: column]) printString, '"').
! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 15:38'!
renderBlankSpotOn: html
	html tableData.! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/6/2011 12:22'!
renderContentOn: html
	html table border: 1; class: 'gameBoard';with: [
		1 to: self rows do: [ :r |
			html tableRow: [
				1 to: self columns do: [ :c |
					self renderTileAt: r at: c on: html]]]]! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/6/2011 12:38'!
renderOccupiedSpotFor: aTile on: html
	html tableData: 	(KmTileRenderable for: aTile)! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/17/2011 20:25'!
renderTileAt: row at: column on: html
	(self tileIsValidAt: row at: column)
		ifTrue: [self renderAvailableSpotFor: row at: column on: html]
		ifFalse: [ | tile |
			tile := self at: row at: column.
			tile isNil 
				ifTrue: [self renderBlankSpotOn: html]
				ifFalse: [self renderOccupiedSpotFor: tile on: html]]! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:48'!
rows
	^game board rows! !

!KmGameBoardComponent methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 22:49'!
tileIsValidAt: row at: column
	| regions gameBoard |
	game currentTile ifNil: [^false].
	gameBoard := game board.
	^gameBoard canPlaceTile: game currentTile at: row at: column.! !

WAComponent subclass: #KmHome
	instanceVariableNames: 'gameBoard summary tileList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 4/25/2011 15:07'!
changeDisplayMode
	self session toggleDisplayMode! !

!KmHome methodsFor: 'hooks' stamp: 'StuartHerring 4/10/2011 14:59'!
children
	| children |
	children := OrderedCollection with: gameBoard with: summary.
	tileList ifNotNil: [ children add: tileList ].
	^children! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 16:10'!
discardTile
	self session game discardTile! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 22:03'!
downloadGame
	self call: KmDownloadGameLink new.! !

!KmHome methodsFor: 'initialization' stamp: 'StuartHerring 3/14/2011 11:58'!
game
	^self session game! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 14:59'!
hideRemaining
	tileList := nil.! !

!KmHome methodsFor: 'initialization' stamp: 'StuartHerring 4/10/2011 14:58'!
initialize
	super initialize.
	gameBoard := KmGameBoardComponent for: self game.
	summary := KmTerritorySummary new.
	tileList := nil.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 4/22/2011 17:13'!
renderContentOn: html
	html div id: #sidebar; with: [
		self renderMenuOn: html.
		html render: summary.
		tileList ifNotNil: [ html div id: #tilelist; with: tileList]].
	self renderCurrentTileOn: html.
	self renderGameBoardOn: html! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 4/3/2011 12:03'!
renderCurrentTileOn: html
		self session currentTile 
			ifNil: [self tilesRemaining 
					ifTrue: [html render: 
						((KmTextTileRenderable text: 'Take Tile') callback: [self takeTile])]
					ifFalse: [html render: (KmTextTileRenderable text: '')]]
			ifNotNil: [html render: 
				((KmTileRenderable for: self session currentTile) callback: [self rotateTile])].
! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/12/2011 12:08'!
renderGameBoardOn: html
	html render: gameBoard! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 18:37'!
renderMenuItem: text do: aBlock on: html
	html listItem: [html anchor callback: aBlock; with: text ]! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 4/25/2011 15:11'!
renderMenuOn: html
	| currentTile |
	currentTile := self session currentTile.
	html heading level: 2; with: 'Menu'.
	html unorderedList 
		id: #menu;
		with: [
			tileList 
				ifNil: [self renderMenuItem: 'Show Remaining Tiles' do: [ self showRemaining ] on: html]
				ifNotNil: [self renderMenuItem: 'Hide Remaining Tiles' do: [ self hideRemaining ] on: html].
			self renderMenuItem: 'Display Mode (', self session displayMode, ')' do: [self changeDisplayMode] on: html.
			self renderMenuItem: 'Download Game' do: [self downloadGame] on: html.
			currentTile ifNotNil: [ self renderMenuItem: 'Rotate Tile' do: [self rotateTile] on: html.
			self game validMoveAvailable ifFalse: [ self renderMenuItem: 'Discard Dead Tile' do: [self discardTile] on: html ]] ]! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/18/2011 19:42'!
rotateTile
	self session currentTile rotate! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 15:02'!
showRemaining
	tileList := KmTileList new
		onAnswer: [ self hideRemaining];
		yourself.! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/17/2011 10:55'!
takeTile
	self session game takeTile! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 4/3/2011 12:06'!
tilesRemaining
	^self session game tileSet size > 0! !

!KmHome methodsFor: 'updating' stamp: 'StuartHerring 3/14/2011 12:16'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss).
	anHtmlRoot title: 'Villages of Khami: ', self game tileSet name.
		
! !

WAComponent subclass: #KmTerritoryInfo
	instanceVariableNames: 'summary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTerritoryInfo methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 23:14'!
renderContentOn: html
	| territories |
	territories := self session game territories.
	html heading level: 2; with: 'Territory Information'.
	html render: summary.
	html anchor callback: [ self answer]; with: 'Close'.! !

!KmTerritoryInfo methodsFor: 'updating' stamp: 'StuartHerring 1/30/2011 23:42'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss)! !

WAComponent subclass: #KmTerritorySummary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTerritorySummary methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 23:46'!
render: aCollection named: aString on: html
	html definitionTerm: aString.
	html definitionData: [
		html render: aCollection size;
			render: ' (';
			render: (aCollection select: [ :t | t isComplete ]) size;
			render: ')']! !

!KmTerritorySummary methodsFor: 'rendering' stamp: 'StuartHerring 4/25/2011 15:00'!
renderContentOn: html
	| territories |
	territories := self session game territories.
	html heading level: 2; with: 'Summary'.
	html definitionList id: #summary; with: [ 
		self render: (territories select: [ :t | t type = #road]) named: 'Roads' on: html.
		self render: (territories select: [ :t | t type = #farm]) named: 'Farms' on: html.
		self render: (territories select: [ :t | t type = #village]) named: 'Villages' on: html.
		self render: territories  named: 'Total' on: html.
	].
! !

WAComponent subclass: #KmTileList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileList class methodsFor: 'testing' stamp: 'StuartHerring 1/9/2011 18:25'!
canBeRoot
	^true! !

!KmTileList methodsFor: 'accessing' stamp: 'StuartHerring 3/14/2011 12:18'!
game
	^self session game! !

!KmTileList methodsFor: 'initialization' stamp: 'StuartHerring 4/10/2011 14:35'!
initialize
	super initialize.! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 4/22/2011 17:12'!
renderContentOn: html
	| id |
	(html heading)
		level: 2;
		with: 'Tiles Remaining'.
	html paragraph: self game tileSet name.
	(html anchor)
		callback: [ self answer ];
		with: 'Close'.
	html unorderedList
		style: 'padding: 0' ;
		id:  (id := html nextId);
		script: (html scriptaculous sortable 
			onUpdate: (html scriptaculous request triggerSortable: id 
			callback: [ :value | self updateTiles: value] ));
		with: [ self renderTilesOn: html].! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 4/10/2011 14:49'!
renderTilesOn: html
	self tiles
		do: [ :t | 
			(html listItem)
				style: 'display: inline-block';
				passenger: t;
				with: (KmTileRenderable for: t) ]! !

!KmTileList methodsFor: 'accessing' stamp: 'StuartHerring 4/10/2011 14:35'!
tiles
	^self session game tileSet instVarNamed: 'tiles'! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 4/10/2011 14:50'!
updateTiles: newCollection
	self session game tileSet instVarNamed: #tiles put: newCollection asOrderedCollection! !

WATask subclass: #KmGameTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameTask class methodsFor: 'class initialization' stamp: 'StuartHerring 4/10/2011 16:43'!
initialize
	(WAAdmin register: self asApplicationAt: 'vok')
		preferenceAt: #sessionClass put: KmSession;
		 addLibrary: PTDevelopmentLibrary;
		  addLibrary: SUDeploymentLibrary.
	WADispatcher default defaultName: 'vok'.
		! !

!KmGameTask methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/10/2011 22:12'!
go
	| game |
	game := self call: KmChooseTileSet new.
	self session game: game.
	self call: KmHome new.	! !

WASession subclass: #KmSession
	instanceVariableNames: 'game frozen displayMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2011 19:42'!
currentTile
	^game currentTile! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 4/25/2011 15:08'!
displayMode
	^displayMode! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 2/1/2011 20:25'!
freeze
	frozen := true! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 18:28'!
game
	^game! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 4/10/2011 22:12'!
game: aGame
	game := aGame.! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 4/25/2011 15:08'!
initialize
	super initialize.
	frozen := false.
	displayMode := #symbolic! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 2/1/2011 20:26'!
isFrozen
	^frozen! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 4/25/2011 15:11'!
toggleDisplayMode
	displayMode := (displayMode = #symbolic) ifTrue: [#literal] ifFalse: [#symbolic]! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 2/1/2011 20:25'!
unfreeze
	frozen := false! !

WAPainter subclass: #KmBlankTileRenderable
	instanceVariableNames: 'callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmBlankTileRenderable methodsFor: 'accessing' stamp: 'StuartHerring 3/20/2011 12:24'!
callback: aBlock
	callback := aBlock! !

!KmBlankTileRenderable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/20/2011 12:26'!
initialize
	 super initialize.
	callback := nil	! !

!KmBlankTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 14:42'!
renderOn: html
	html table
		onClick: (callback ifNotNil: ['window.location = "', (html urlForAction:  callback) printString, '";']);
		class: (KmTile name); 
		class: (callback ifNotNil: ['clickable']);
			with: [self renderTileOn: html]! !

KmBlankTileRenderable subclass: #KmTextTileRenderable
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTextTileRenderable class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/20/2011 12:33'!
text: aString 
	^self basicNew
		initializeWithText: aString;
		yourself! !

!KmTextTileRenderable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/20/2011 12:33'!
initializeWithText: aString
	self initialize.
	text := aString! !

!KmTextTileRenderable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/20/2011 14:24'!
renderTileOn: html
	html tableRow: [html tableData class: 'text'; with: text]! !

KmBlankTileRenderable subclass: #KmTileRenderable
	instanceVariableNames: 'tile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileRenderable class methodsFor: 'instance creation' stamp: 'StuartHerring 1/13/2011 19:40'!
for: aTile
	^self basicNew
		initializeWithTile: aTile;
		yourself! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/31/2011 23:07'!
classFor: aRegion
	^String streamContents: [ :s |
		s nextPutAll: aRegion type.
		aRegion isComplete ifTrue: [s nextPut: $C]]! !

!KmTileRenderable methodsFor: 'initialization' stamp: 'StuartHerring 3/20/2011 12:25'!
initializeWithTile: aTile
	self initialize.
	tile := aTile.! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 14:24'!
renderBlankOn: html
	html tableData! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 4/25/2011 15:15'!
renderLiteralTileOn: html
		html tableRow: [
			self renderBlankOn: html.  
			self renderRegion: TopLeft on: html.
			self renderRegion: Top on: html.
			self renderRegion: TopRight on: html.
			self renderBlankOn: html.		].
		html tableRow: [ 
			self renderRegion: LeftTop on: html.
			self renderBlankOn: html.  
			self renderRegion: CentreTop on: html.
			self renderBlankOn: html.  
			self renderRegion: RightTop on: html.
		].
		html tableRow: [
			self renderRegion: Left on: html.
			self renderRegion: CentreLeft on: html.
			self renderRegion: Centre on: html.
			self renderRegion: CentreRight on: html.
			self renderRegion: Right on: html.
			].
		html tableRow: [ 
			self renderRegion: LeftBottom on: html.
			self renderBlankOn: html.  
			self renderRegion: CentreBottom on: html.
			self renderBlankOn: html.  
			self renderRegion: RightBottom on: html.
		].
		html tableRow: [
			self renderBlankOn: html.  
			self renderRegion: BottomLeft on: html.
			self renderRegion: Bottom on: html.
			self renderRegion: BottomRight on: html.
			self renderBlankOn: html.  
		]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 4/25/2011 15:14'!
renderRegion: aRegion on: html
	html tableData 
		class: (self classFor: (tile at: aRegion));
		with: [self session displayMode = #literal ifTrue: [html text: (tile at: aRegion) class codeCharacter ]]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 4/26/2011 12:29'!
renderSymbolicTileOn: html
		html tableRow: [
			self renderWallRegion: TopLeft on: html.
			self renderRegion: TopLeft on: html.
			self renderRegion: Top on: html.
			self renderRegion: TopRight on: html.
			self renderWallRegion: TopRight on: html.
		].
		html tableRow: [ 
			self renderRegion: LeftTop on: html.
			self renderWallRegion: LeftTop on: html.
			self renderRegion: CentreTop on: html.
			self renderWallRegion: TopRight on: html.
			self renderRegion: RightTop on: html.
		].
		html tableRow: [
			self renderRegion: Left on: html.
			self renderRegion: CentreLeft on: html.
			self renderRegion: Centre on: html.
			self renderRegion: CentreRight on: html.
			self renderRegion: Right on: html.
			].
		html tableRow: [ 
			self renderRegion: LeftBottom on: html.
			self renderWallRegion: BottomLeft on: html.
			self renderRegion: CentreBottom on: html.
			self renderWallRegion: RightBottom on: html.
			self renderRegion: RightBottom on: html.
		].
		html tableRow: [
			self renderWallRegion: BottomLeft on: html.
			self renderRegion: BottomLeft on: html.
			self renderRegion: Bottom on: html.
			self renderRegion: BottomRight on: html.
			self renderWallRegion: RightBottom on: html.
		]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 4/25/2011 15:16'!
renderTileOn: html
	self session displayMode = #symbolic 
		ifTrue: [self renderSymbolicTileOn: html  ]
		ifFalse: [self renderLiteralTileOn: html  ]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 4/26/2011 12:31'!
renderWallRegion: aRegion on: html
	html tableData 
		class: ((tile at: aRegion) isWall 
			ifTrue: ['wall'] 
			ifFalse: [self classFor: (tile at: aRegion)] )! !
KmGameTask initialize!
